# TODO OPTIMIZATION
# -    in_bytes / out_bytes. 
#       -    /,
#   ..   defined  exists  .  
#          read/write   .
#
# -      UDP_CONNECTED::_real_read, 
#      .., , DNS  512   .
#
# -   ( @ISA)   ԣ 
#      write, _write, wait_for, _set_wait_for  .
#
# -  write()    $buf  {out_buf}   
#    -     .    UDP.
#   NOTE         -  
#           POWER::Event::IO::UDP_CONNECTED::write(), 
#            write, _write  _real_write.
#               $buf  
#             syswrite()    
#           {out_buf},      
#            .
#               - 10-15%      
#                     (   write()).
#              -     .
#           : .      . :-(
#
# -  io_wait()   '$events &= ~($EPOLLHUP|$EPOLLERR)',
#       if-    .
#
# -  " close"    
#     :
#   1) if (ref($self->{cb}) && ref($self->{cb}) ne 'CODE')
#      weaken  {cb}
#      weaken  {_cb}[0]
#      -->    
#   2) if ($_->{cb})
#      -->      io_wait()
#   3) if ($IO_for[ $self->{fd} ]{cb})
#      -->     fd    fd 
#            (   fh  close($io->{fh})
#           $io->close())
#           ...
#
# -    sysread ( $STREAM)   - 
#    "short read", EOF  .    
#     ,      
#    EOF.
#
# -    weaken      @Timer_*
#        I/O,     
#   weaken-  .


#       I/O:
# - new()  ,       
#        ţ .
# -          
#        (   , 
#   ,   weaken).
# - close()   -weaken      
#   .
# -    ݣ new() ,   
#   ( callback ӣ-  ţ ).
# -      ,     close() 
#       -weaken     ( 
#     weaken-    POWER::Event::IO).


#     :
# -      $n   - ,
#     ,    $n .
# -  - ,       ,
#          I/O,  ģ 
#    .
# -   $n   ,   ,
#        "timed out",   
#      $m     
#         (   ).
# 
#  :
# -       (  
#    ""    ).
#   NOTE:           
#             (.  1/10 ),   
#              @Timer.
# - ģ     @Timer ( ).
# -   $n-    $self:
#       unshift @{ $Timer[$n] }, $self;
#       weaken $Timer[$n][0];
# -    ,    ,   
#    :
#       for my $obj (@{ shift @Timer || [] }) {
#           next if !$obj;      # skip destroyed weaken references
#           ...                 # process $obj
#       }
# 
#        
#  (  callback    ,
#          ),
#      ޣ   
#     (      ),
# /     ,   .. "" -
#   .   callback   
# ,   ""    .  
# callback   ,     
#       .


#   state    .
#   :
# -      epoll_add()
# -    epoll_mod()
# -   DNS-   host  IP-
# 
# new()
#         fh:
#             state=$CONNECTING  type  $CONNECTED:
#                state=$CONNECTING
#           :
#                state=$HANDLING
#       :
#             host  IP:
#                _query_dns()
#           :
#                _resolved()
#         out_buf:
#            state=$HANDLING:
#                _real_write()
#                _real_write()    out_buf:
#                    EPOLLOUT
#           :
#                 _write_needed
#        state!=$HANDLING  type  $CONNECTED:
#            EPOLLOUT
#        epoll_add()
# _query_dns()
#        state=$RESOLVING
# _resolved()
#        type  $CONNECTED:
#            state=$CONNECTING
#       :
#            state=$HANDLING
#              _write_needed:
#                $self->_write()


# Nonblock() vs fcntl() vs ioctl():
#  , ioctl  ""     
#    POSIX     ioctl   
#      (fcntl, ).
#    IMHO      ioctl -
#         
# . :)    ioctl     ,  fcntl   -
#  ioctl! :-)       POWER::Utils::IO
#    perl- Nonblock().
#   ioctl-.  perldoc : require "ioctl.ph".
#    . :)   : require "asm/ioctls.ph".
#  - ioctl-    man ioctl_list,  
#         .


package POWER::Event::IO;

use version; $VERSION = qv('0.0.2');    # update POD & Changes & README

use warnings;
use strict;
use Carp;

use Scalar::Util qw( weaken refaddr dualvar );
use Errno qw( EAGAIN EINTR EINPROGRESS );
use Socket;

use Perl6::Export::Attrs;

use POWER::Epoll 2.0.0;
use POWER::Event::Timer;


# Cache for speed:
our ($EAGAIN, $EINTR, $EINPROGRESS);
*EAGAIN         = \EAGAIN;
*EINTR          = \EINTR;
*EINPROGRESS    = \EINPROGRESS;
our ($EPOLLIN, $EPOLLOUT, $EPOLLHUP, $EPOLLERR, $EPOLLPRI);
*EPOLLIN        = \EPOLLIN;
*EPOLLOUT       = \EPOLLOUT;
*EPOLLHUP       = \EPOLLHUP;
*EPOLLERR       = \EPOLLERR;
*EPOLLPRI       = \EPOLLPRI;
our ($AF_INET, $PROTO_TCP, $PROTO_UDP, $SOCK_STREAM, $SOCK_DGRAM);
*PROTO_TCP      = \getprotobyname('tcp');
*PROTO_UDP      = \getprotobyname('udp');
*AF_INET        = \AF_INET;
*SOCK_STREAM    = \SOCK_STREAM;
*SOCK_DGRAM     = \SOCK_DGRAM;
our ($SOL_SOCKET, $SO_REUSEADDR, $REUSEADDR_VAL, $SOMAXCONN);
*SOL_SOCKET     = \SOL_SOCKET;
*SO_REUSEADDR   = \SO_REUSEADDR;
*REUSEADDR_VAL  = \pack('L!', 1);
*SOMAXCONN      = \SOMAXCONN;
our ($FIONBIO, $IOCTL_TRUE);
*FIONBIO        = \0x5421;
$IOCTL_TRUE     = "\1\0\0\0";


# :
our ($ERR, $RESOLVED, $CONNECTED, $ACCEPTED, $IN, $OUT, $EOF, $SENT);
*ERR            = \(1<<0);
*RESOLVED       = \(1<<1);
*CONNECTED      = \(1<<2);
*ACCEPTED       = \(1<<3);
*IN             = \(1<<4);
*OUT            = \(1<<5);
*EOF            = \(1<<6);
*SENT           = \(1<<7);

# :
our ($STREAM, $LISTEN, $UDP, $UDP_CONNECTED);
*STREAM         = \(1<<0);
*LISTEN         = \(1<<1);
*UDP            = \(1<<2);
*UDP_CONNECTED  = \(1<<3);

# :
our ($RESOLVING, $CONNECTING, $HANDLING);
*RESOLVING      = \(1<<0);
*CONNECTING     = \(1<<1);
*HANDLING       = \(1<<2);

# :
our ($STREAM_IO, $PACKET_IO);
*STREAM_IO      = \(1<<0);
*PACKET_IO      = \(1<<1);

#    :
my @Type2Event;
$Type2Event[ $STREAM        ]   = $ERR|$RESOLVED|$CONNECTED|$IN|$OUT|$EOF|$SENT;
$Type2Event[ $LISTEN        ]   = $ERR|$RESOLVED|$ACCEPTED;
$Type2Event[ $UDP           ]   = $ERR|$IN|$OUT;
$Type2Event[ $UDP_CONNECTED ]   = $ERR|$RESOLVED|$IN|$OUT;
my @Type2Style;
$Type2Style[ $STREAM        ]   = $STREAM_IO;
$Type2Style[ $LISTEN        ]   = $PACKET_IO;
$Type2Style[ $UDP           ]   = $PACKET_IO;
$Type2Style[ $UDP_CONNECTED ]   = $PACKET_IO;
my @Type2Class;
$Type2Class[ $STREAM        ]   = 'POWER::Event::IO::STREAM';
$Type2Class[ $LISTEN        ]   = 'POWER::Event::IO::LISTEN';
$Type2Class[ $UDP           ]   = 'POWER::Event::IO::UDP';
$Type2Class[ $UDP_CONNECTED ]   = 'POWER::Event::IO::UDP_CONNECTED';

#    (     ):
our ($TICK_RATE, $TO_DNS, $TO_DNS_RESEND, $TO_CONNECT, $TO_WRITE);
*TICK_RATE      = \0.1;         # timer rate (in float seconds)
                                # ALL TIMEOUTS BELOW IN "ticks" AND >= 1 !
$TO_DNS
    = int 30 / $TICK_RATE + 0.5;# default timeout for receiving dns reply
$TO_DNS_RESEND
    = int  2 / $TICK_RATE + 0.5;# default timeout for resending dns requests
$TO_CONNECT
    = int 30 / $TICK_RATE + 0.5;# default timeout for connect
$TO_WRITE
    = int 30 / $TICK_RATE + 0.5;# default timeout for write


$SIG{PIPE}  = 'IGNORE' if !defined $SIG{PIPE};


# ,     I/O:
my @IO_for;                     # map fileno(fh) => POWER::Event::IO object
my %Ready;                      #      callback
my %DNS;                        # map DNS query ID => POWER::Event::IO object


#  :
my (@Timer_dns, @Timer_dns_resend, @Timer_connect, @Timer_write);
my $Tick = 0;                   # how many times tick_tack() was called
set_timer({ every => $TICK_RATE, cb => \&_tick_tack });


#   ...
my $EPFD    = epoll_create(100);
my $RE_IP   = qr{\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}}xms;


#   ,   inet_aton().
# WARNING      DNS- ( 
#           /etc/resolve.conf,    ).
my $DNS_ID  = 0;
my ($ns)    = `cat /etc/resolv.conf` =~ /^\s*nameserver\s+($RE_IP)\s*$/xms;
my $DNS     = POWER::Event::IO->new({
    host        => $ns || '127.0.0.1',
    port        => 53,
    type        => $UDP_CONNECTED,
    wait_for    => $IN,
    cb          => \&_process_dns_reply,
    ID          => 0,                   # id for next DNS query
});


#   ! :)
sub IMPORT {
    my $pkg = caller(0);
    no strict 'refs';
    *{$pkg.'::'.$_} = \${$_} for qw(
        ERR RESOLVED CONNECTED ACCEPTED IN OUT EOF SENT
        STREAM LISTEN UDP UDP_CONNECTED
        RESOLVING CONNECTING HANDLING
        );
}

#    :
sub _tick_tack {
    $Tick++;
    #   .       
    # ӣ ݣ   $RESOLVING,   .
    for my $io (@{ shift @Timer_dns || [] }) {
        next unless $io;
        next if $io->{state} != $RESOLVING;
        $io->{_events}         |= $ERR;
        $io->{_err}             = dualvar(-1, q{resolving timed out});
        $Ready{ $io->{_id} }    = $io;
        #    ģ    $DNS->{ID}
        delete $DNS{ $io->{_dns_id} };
    }
    #    DNS-. (  
    # ,  -   -   
    #   ...)      
    #    $RESOLVING,    
    #   .
    for my $io (@{ shift @Timer_dns_resend || [] }) {
        next unless $io;
        next if $io->{state} != $RESOLVING;
        next if !$DNS{ $io->{_dns_id} };    # don't resend after timeout
        #    ,      - 
        # ݣ   $TO_DNS_RESEND... , ,  udp
        #       if    
        $DNS->write($io->{_dns_query})
            if !defined $DNS->{out_buf};
        # -1  ..    tick_tack()  
        # (  $Timer_dns_resend[0]) ģ  
        #  
        unshift @{ $Timer_dns_resend[$TO_DNS_RESEND-1] }, $io;
        weaken     $Timer_dns_resend[$TO_DNS_RESEND-1][0];
    }
    for my $io (@{ shift @Timer_connect || [] }) {
        next unless $io;
        next if $io->{state} != $CONNECTING;
        # $io->close()    ,    
        # .    $io->close()   (.. 
        #   ),     ,
        #   .
        $io->{_events}         |= $ERR;
        $io->{_err}             = dualvar(-1, q{connecting timed out});
        $Ready{ $io->{_id} }    = $io;
    }
    for my $io (@{ shift @Timer_write || [] }) {
        next unless $io;
        #       Σ
        if ($io->{_epoll} & $EPOLLOUT) {
            #  tick,     
            my $to_tick = $io->{_tick_write} + $TO_WRITE + 1;
            #        -  
            # ԣ       $io->close(), 
            #          (..
            # _timer_write  )
            if ($to_tick <= $Tick) {
                $io->{_events}         |= $ERR;
                $io->{_err}             = dualvar(-1, q{writing timed out});
                $Ready{ $io->{_id} }    = $io;
            }
            #   ,     $Tick==$to_tick
            else {
                unshift @{ $Timer_write[ $to_tick - $Tick - 1 ] }, $io;
                weaken     $Timer_write[ $to_tick - $Tick - 1 ][0];
            }
        }
        #      ,   
        # EAGAIN    _write()
        else {
            $io->{_timer_write} = 0;
        }
    }
}

#    DNS-:
sub _query_dns {
    my ($self) = @_;
    $self->{state} = $RESOLVING;
    if (length($self->{host}) >= 254) {
        $self->{_events}       |= $ERR;
        $self->{_err}           = dualvar(-1, q{too long host name});
        $Ready{ $self->{_id} }  = $self;
        return;
    }
    ($DNS_ID += 1) %= 0xFFFF+1;
    $DNS{ $DNS_ID }  = $self;
    weaken $DNS{ $DNS_ID };
    $self->{_dns_id} = $DNS_ID;
    $self->{_dns_host}
        = join(q{}, map {chr(length).$_} split /\./, lc($self->{host}))."\0";
    $self->{_dns_query}
        = pack('nnnnnn a* nn',$DNS_ID,0x0100,1,0,0,0,$self->{_dns_host},1,1);
    $DNS->write($self->{_dns_query})
        if !defined $DNS->{out_buf};
    unshift @{ $Timer_dns[$TO_DNS] }, $self;
    weaken     $Timer_dns[$TO_DNS][0];
    unshift @{ $Timer_dns_resend[$TO_DNS_RESEND] }, $self;
    weaken     $Timer_dns_resend[$TO_DNS_RESEND][0];
    return;
}

#    DNS-:
{ my $d = qr/[^\x00\xc0-\xff]*(?:\x00|[\xc0-\xff].)/xms;
sub _process_dns_reply {
    my ($io) = @_;
    die "Oops. DNS resolver just died: $io->{err}" if $io->{events} & $ERR;
    my ($id,$flags,undef,$an) = unpack 'nnnn', my $pkt = delete $io->{in_buf};
    #   ""  -   ID (,
    #          
    #   $TO_DNS_RESEND)    ID   host
    # (  DNS-,  ID-   "").
    return if !$DNS{$id};
    return if $pkt !~ s/^.....\x01......\Q$DNS{$id}{_dns_host}\E.\x01..//xms;
    #   .
    if ($flags &= 0x0f) {
        $DNS{$id}->{_events}       |= $ERR;
        $DNS{$id}->{_err}           = dualvar(-1, 'dns error: '.
                                        ($flags==3 ? 'NXDOMAIN' : 'SRVERROR'));
        $Ready{ $DNS{$id}->{_id} }  = $DNS{$id};
    }
    elsif (!(   ($pkt =~ s/^[^\x00\xC0-\xFF]*(?:\x00|[\xC0-\xFF].).\x01........//s) ||
                (($an > ($pkt =~ s/\G$d.(?:[\x02\x05\x0C].{8}$d|\x06.{8}$d$d.{20}|\x0F.{8}..$d)//sog)) &&
                 ($pkt =~ s/^$d.\x01.{8}//so))  )) {
        $DNS{$id}->{_events}       |= $ERR;
        $DNS{$id}->{_err}           = dualvar(-1, 'dns error: NODATA');
        $Ready{ $DNS{$id}->{_id} }  = $DNS{$id};
    }
    # IP  ...
    else {
        $DNS{$id}->_resolved(sprintf '%d.%d.%d.%d', unpack 'CCCC', $pkt);
    }
    delete $DNS{$id};
    return;
}}

#   IP-:
# -  ip
# -  state
# -   $RESOLVED,    fh 
#   connect/bind/listen
sub _resolved {
    my $self    = shift;
    $self->{ip} = shift;
    $self->_init();
    #  host    DNS ,   _init()
    #     ,      epoll_add().
    #      -    new() -
    #   epoll_add(), _write(),  _real_write(), epoll_add() ...
    #      IMHO    ..   ,
    #      $UDP_CONNECTED,   
    #  _real_write()  ģ   .
    epoll_add($EPFD, $self->{fd}, $self->{_epoll})
        if $self->{state} == $RESOLVING;
    if ($Type2Event[ $self->{type} ] & $CONNECTED) {
        $self->{state} = $CONNECTING;
        unshift @{ $Timer_connect[$TO_CONNECT] }, $self;
        weaken     $Timer_connect[$TO_CONNECT][0];
    }
    else {
        $self->{state} = $HANDLING;
        $self->_write() if $self->{_write_needed};
    }
    if ($self->{wait_for} & $RESOLVED) {
        $self->{_events}       |= $RESOLVED;
        $Ready{ $self->{_id} }  = $self;
    }
}

#   I/O:
# -  
# -     (   fh
#    host+port,  fh    
#    host):
#       fh, type, state, wait_for, cb
# -    :
#       method, in_buf_limit, out_buf, out_pos
# -    (-weaken)   @IO_for
# -   {out_buf}        state $HANDLING,
#      _real_write()
# -      epoll  
#    wait_for, state    
#   _real_write(),   
sub new {
    my ($class, $opt_ref) = @_;
    croak 'Usage: POWER::Event::IO->new({ OPTIONS })'
        if @_ != 2 || ref($opt_ref) ne 'HASH';
    croak '{cb} required'
        if !defined $opt_ref->{cb};
#{ no warnings qw(numeric uninitialized);
    croak '{type} wrong'
        if exists $opt_ref->{type}
        && $opt_ref->{type} != $STREAM
        && $opt_ref->{type} != $LISTEN 
        && $opt_ref->{type} != $UDP_CONNECTED
        && $opt_ref->{type} != $UDP 
        ;
#}
    my $type = $opt_ref->{type} || $STREAM;
    my $buf  = $Type2Style[$type] == $PACKET_IO ? undef : q{};
    my $self = bless {
        #  ,     :
        fh          => undef,
        host        => undef,
        port        => undef,
        type        => $type,
        state       => 0,
        wait_for    => 0,
        cb          => $opt_ref->{cb},
        #       :
        method      => 'IO',
        in_buf_limit=> undef,
        out_buf     => $buf,                # modified on: $OUT|$SENT
        out_pos     => undef,               # modified on: $OUT|$SENT
        #  new():
        events      => 0,                   # modified on: any waited event
        err         => undef,               # modified on: $ERR
        in_buf      => $buf,                # modified on: $ACCEPTED|$IN|$EOF
        in_bytes    => 0,                   # modified on: $IN|$EOF
        in_paddr    => undef,               # modified on: $IN|$ACCEPTED
        out_bytes   => 0,                   # modified on: $OUT|$SENT
        out_paddr   => undef,               # destination for $UDP write
        ip          => undef,               # modified on: $RESOLVED
        is_eof      => undef,               # modified on: $EOF
        fd          => undef,               # just cached fileno(fh)
        _epoll      => 0,                   # waiting epoll events
        _events     => 0,                   # events for next callback call
        _err        => undef,               # error  for next callback call
        _id         => 0,                   # unique key for %Ready
        _cb         => [],                  # struct cached for POWER::Event
        _dns_id     => undef,               # $DNS_ID for this object
        _dns_host   => undef,               # dns-packed {host}
        _dns_query  => q{},                 # DNS query packet
        _tick_write => 0,                   # $Tick value at last writing
        _timer_write=> 0,                   # TRUE if $self in @Timer_write
        _write_needed=>0,                   # TRUE if must _write() when state
                                            #   become $HANDLING
        }, $Type2Class[$type];
    #        as is.
    for my $k ( grep {m/\A(?:method|in_buf_limit|out_buf|out_pos|[A-Z].*)\z/xms}
                keys %$opt_ref ) {
        $self->{$k} = $opt_ref->{$k};
    }
    #      wait_for.
    $self->_set_wait_for($opt_ref->{wait_for}) if $opt_ref->{wait_for};
    #     I/O,    
    #        callback (. %Ready).
    $self->{_id} = refaddr($self);
    #    cb,     .  
    #     $io->close(),  close()  
    # .
    # OPTIMIZATION    [ $cb, $method, $self ] 
    #                  io_wait()  POWER::Event 
    #                    callback.
    $self->{_cb} = [ $self->{cb}, $self->{method}, $self ];
    weaken $self->{_cb}[2];
    if (ref($self->{cb}) && ref($self->{cb}) ne 'CODE') {
        weaken $self->{cb};
        weaken $self->{_cb}[0];
    }

    ##########################
    #  fh  state ###
    ##########################

    #    fh,   state  $CONNECTING  $HANDLING -
    #      state.
    if (defined $opt_ref->{fh}) {
        $self->{fh} = $opt_ref->{fh};
        if (!$opt_ref->{state}) {
            $self->{state} = $HANDLING;
        }
        elsif ($Type2Event[$type] & $CONNECTED) {
            croak 'only allowed value to initialize {state} is $CONNECTING'
                if $opt_ref->{state} != $CONNECTING;
            $self->{state} = $CONNECTING;
            unshift @{ $Timer_connect[$TO_CONNECT] }, $self;
            weaken     $Timer_connect[$TO_CONNECT][0];
        }
        else {
            croak 'you can set {state} only if {type} support $CONNECTED';
        }
    }
    #    state   fh   host.
    else {
        my ($socktype, $proto)
            = ($type & ($UDP|$UDP_CONNECTED))   ? ($SOCK_DGRAM,  $PROTO_UDP)
            :                                     ($SOCK_STREAM, $PROTO_TCP)
            ;
        #       ( 
        # -   fd)  croak  $io  fh
        #    .
        socket($self->{fh}, $AF_INET, $socktype, $proto) or croak "socket: $!";
        ioctl($self->{fh}, $FIONBIO, $IOCTL_TRUE) or croak "ioctl: $!";
        croak '{fh} or {host}+{port} required'
            if !defined $opt_ref->{host} || !defined $opt_ref->{port};
        $self->{host}   = $opt_ref->{host};
        $self->{port}   = $opt_ref->{port};
        # OPTIMIZATION    host     IP-, 
        #                . :)
        if ($self->{host} =~ /\A$RE_IP\z/xms) {
            $self->_resolved($self->{host});
        }
        #    .
        else {
            $self->_query_dns();
        }
    }

    ############################################
    ###    epoll  @IO_for ###
    ############################################

    $self->{fd} = fileno($self->{fh});
    croak '{fh} is not open FILEHANDLE'     if !defined $self->{fd};

    #  $fd  epoll;   {out_buf}   _write().
    # 
    #   fd  epoll   EPOLLIN   
    #      ($ACCEPTED  $IN  $EOF);
    # EPOLLOUT    state != $HANDLING    type
    #    $CONNECTED (..    
    # connect), ..  EPOLLOUT      
    # connect ۣ      .
    # 
    # OPTIMIZATION   state != $HANDLING,    out_buf, 
    #                 _write()    {_write_needed},
    #                _write()    state  
    #                $HANDLING.
    #                    _write()
    #                new().
    # 
    # OPTIMIZATION   state = $HANDLING    out_buf, 
    #                 _write()  epoll_add() 
    #               _real_write()  epoll_add(),   _real_write()
    #                ۣ,   EPOLLOUT.
    #                  epoll_mod()   _write()
    #                ģ.
    $self->{_epoll} |= $EPOLLIN
        if $self->{wait_for} & ($ACCEPTED|$IN|$EOF);
    $self->{_epoll} |= $EPOLLOUT
        if $self->{state} != $HANDLING && $Type2Event[$type] & $CONNECTED;
    if (defined $opt_ref->{out_buf}) {
        if ($self->{state} == $HANDLING) {
            $self->{_epoll} |= $EPOLLOUT if !$self->_real_write();
        }
        else {
            $self->{_write_needed} = 1;
        }
    }
    epoll_add($EPFD, $self->{fd}, $self->{_epoll})
        if $self->{state} != $RESOLVING;

    #     @IO_for.
    if ($IO_for[ $self->{fd} ]) {
        croak 'you must do $io->close() first'
            if $IO_for[ $self->{fd} ]{cb};
        $IO_for[ $self->{fd} ]->close();
    }
    $IO_for[ $self->{fd} ] = $self;
   
    return $self;
}

#  wait_for     epoll.
sub wait_for {
    my ($self, $wait_for) = @_;
    croak 'Usage: $io->wait_for( FLAGS )' if @_ != 2;
    $self->_set_wait_for($wait_for);
    my $epoll
        = ($self->{_epoll} & ~ $EPOLLIN)
        | (($self->{wait_for} & ($ACCEPTED|$IN|$EOF)) ? $EPOLLIN : 0)
        ;
    if ($self->{_epoll} != $epoll) {
        epoll_mod($EPFD, $self->{fd}, $epoll);
        $self->{_epoll} = $epoll;
    }
    return;
}

#  wait_for    .
sub _set_wait_for {
    my ($self, $wait_for) = @_;
#{ no warnings 'numeric';
    croak 'wrong event mask'
        if !defined($wait_for)
        || $wait_for ne 0+$wait_for
        || $wait_for & ~$Type2Event[ $self->{type} ];
#}
    croak 'you must set {in_buf_limit} if you wanna $EOF without $IN'
        if $wait_for & $EOF
        && !($wait_for & $IN)
        && !defined $self->{in_buf_limit};
    $self->{wait_for} = $wait_for;
    return;
}

#     out_buf,   .
#   out_buf,   .
sub write {
    my ($self, $buf) = @_;
    croak 'Usage: $io->write( [$buf] )' if !(1 <= @_ && @_ <= 2);
    if (defined $buf) {
        if ($Type2Style[ $self->{type} ] == $PACKET_IO) {
            croak q{previous packet isn't sent yet} if defined $self->{out_buf};
            $self->{out_buf} = $buf;
        }
        else {
            $self->{out_buf} .= $buf;
        }
    }
    if ($self->{state} != $HANDLING) {
        $self->{_write_needed} = 1;
    }
    elsif (!($self->{_epoll} & $EPOLLOUT)) {
        $self->_write();
    }
    return;
}

#     I/O.
#    epoll,  .
# WARNING _write()     state=$HANDLING.
sub _write {
    my ($self) = @_;
    #   ݣ   ,  _real_write()
    #   (   ݣ    
    # )       EPOLLOUT  ,
    #    _write()  "".
    my $write_complete = !($self->{_events} & $ERR) && $self->_real_write();
    if ($write_complete) {
        if ($self->{_epoll} & $EPOLLOUT) {
            $self->{_epoll} &= ~$EPOLLOUT;
            epoll_mod($EPFD, $self->{fd}, $self->{_epoll});
        }
    }
    else {
        if (!($self->{_epoll} & $EPOLLOUT)) {
            $self->{_epoll} |= $EPOLLOUT;
            epoll_mod($EPFD, $self->{fd}, $self->{_epoll});
            #    ,    _tick_write
            #        $TO_WRITE  
            # __ 
            if ($self->{_timer_write}) {
                $self->{_tick_write} = $Tick;
            }
            #    
            else {
                unshift @{ $Timer_write[$TO_WRITE] }, $self;
                weaken     $Timer_write[$TO_WRITE][0];
                $self->{_timer_write} = 1;
            }
        }
    }
    return;
}

#   I/O.
sub close {
    my ($self) = @_;
    delete $Ready{ $self->{_id} };
    $IO_for[ $self->{fd} ] = undef;
    close $self->{fh};
    return;
}

#     epoll.
#   callback   .
sub io_wait :Export(:event) {
    croak  q{usage: io_wait TIMEOUT} if @_ != 1;
    my ($timeout) = @_;
#{ no warnings 'numeric';
    croak qq{wrong TIMEOUT $timeout}
        if defined $timeout && ($timeout ne 0+$timeout || $timeout < 0);
#}
    $timeout = 0 if keys %Ready;
    my ($status, $events) = epoll_wait($EPFD, $timeout);
    return undef if $status==-1;    # EINTR only!
    for (@$events) {
        my ($fd, $events) = @$_;
        my $io = $IO_for[$fd];
        croak qq{Internal error: no I/O object for events=$events on fd=$fd}
            if !$io;
#warn ">>> ".($DNS->{fd}==$fd ? 'DNS' : "FD=$fd")." events=".join(q{,},($events & $EPOLLIN  ? 'IN' : ()),($events & $EPOLLOUT ? 'OUT' : ()),($events & $EPOLLHUP ? 'HUP' : ()),($events & $EPOLLERR ? 'ERR' : ()))."\n";
        if ($io->{state} != $HANDLING && $events & $EPOLLOUT) {
            # state    $RESOLVING ..  EPOLLOUT
            #   state=$RESOLVING   
            #  $CONNECTED,    EPOLLOUT  
            #   connect()   ... .
            $io->{state} = $HANDLING;
            #    $CONNECTED    
            if ($io->{wait_for} & $CONNECTED) {
                $io->{_events} |= $CONNECTED;
                $Ready{ $io->{_id} } = $io;
            }
#warn ">>>   HANDLING!\n";
        }
#warn(">>>   _real_read\n"),
        $io->_real_read(), $events &= ~($EPOLLHUP|$EPOLLERR)
            if !($io->{_events} & $ERR)
            && $events & ($EPOLLIN|$EPOLLHUP|$EPOLLERR)
            ;
#warn(">>>   _write\n"),
        $io->_write() if $events & ($EPOLLOUT|$EPOLLHUP|$EPOLLERR);
    }
    my @events = values %Ready;
    %Ready = ();
    return $status, map {
            if ($_->{cb}) {
                $_->{events}    = $_->{_events};
                $_->{err}       = $_->{_err};
                $_->{_events}   = 0;
                $_->{_err}      = undef;
                $_->{_cb};
            }
            else {
                $_->close();
            }
        } @events;
}


package POWER::Event::IO::UDP_CONNECTED;
use base qw( POWER::Event::IO );
use Carp;
use Socket;
use Scalar::Util qw( dualvar );

#       ..   
#  ,       
#  EPOLLERR.
sub _init {
    my ($self) = @_;
    connect($self->{fh}, sockaddr_in($self->{port}, inet_aton($self->{ip})));
    return;
}

sub _real_read {
    my ($self) = @_;
    return if defined $self->{in_buf};
    #   ,  UDP   65507 
    #  -  EMSGSIZE.
    #        
    #   (DNS-   512 ), 
    #        .
    my $n = sysread $self->{fh}, $self->{in_buf}, 0xFFFF;
    if (defined $n) {
        $self->{in_bytes}      += $n;
        #  if     ..   wait_for 
        #  $IN,   UDP_CONNECTED  EPOLLIN  , 
        # _real_read()   ...
        if ($self->{wait_for} & $IN) { # no $EOF for $UDP_CONNECTED !
            $self->{_events}       |= $IN;
            $Ready{ $self->{_id} }  = $self;
        }
    }
    elsif ($! != $EAGAIN) { #   EAGAIN  ģ,     ?
        $self->{_err}           = $!;
        $self->{_events}       |= $ERR;
        $Ready{ $self->{_id} }  = $self;
    }
    return;
}

sub _real_write {
    my ($self) = @_;
    return 1 if !defined $self->{out_buf};
    my $n = syswrite $self->{fh}, $self->{out_buf};
    if (defined $n) {
        $self->{_tick_write}    = $Tick;
        #   ,  out_buf    , 
        #       EMSGSIZE.
        $self->{out_buf}        = undef;
        $self->{out_bytes}     += $n;
        if ($self->{wait_for} & $OUT) { # no $SENT for $UDP_CONNECTED !
            $self->{_events}       |= $OUT;
            $Ready{ $self->{_id} }  = $self;
        }
        return 1;
    }
    elsif ($! != $EAGAIN) { #   EAGAIN  ģ,     ?
        $self->{_err}           = $!;
        $self->{_events}       |= $ERR;
        $Ready{ $self->{_id} }  = $self;
    }
    return 0;
}


package POWER::Event::IO::UDP;
use base qw( POWER::Event::IO );
use Carp;
use Socket;
use Scalar::Util qw( dualvar );

#   -   TODO  type=$UDP:
#
#  $UDP      recv/send.   ?
#
# ݣ -   out_host/out_ip  out_port  
#  out_paddr.   out_host   ,
#     -   ( 
# ӣ- , ).
#
#  ݣ    in_paddr  in_ip  in_port.
# , -,     ,    
# .
#
# ,   UDP-,    listen_host 
# listen_port.         $UDP - 
# listen_host  listen_ip   bind()   .

sub _init {
    die q{don't know what to do with resolved IP for UDP};
}

sub _real_read {
    my ($self) = @_;
    return if defined $self->{in_buf};
    #   ,  UDP   65507 
    #  -  EMSGSIZE.
    #        
    #   (DNS-   512 ), 
    #        .
    $self->{in_paddr} = recv $self->{fh}, $self->{in_buf}, 0xFFFF, 0;
    if (defined $self->{in_paddr}) {
        $self->{in_bytes}      += length($self->{in_buf});
        #  if     ..   wait_for 
        #  $IN,   UDP  EPOLLIN  , 
        # _real_read()   ...
        if ($self->{wait_for} & $IN) { # no $EOF for $UDP !
            $self->{_events}       |= $IN;
            $Ready{ $self->{_id} }  = $self;
        }
    }
    elsif ($! != $EAGAIN) { #   EAGAIN  ģ,     ?
        $self->{_err}           = $!;
        $self->{_events}       |= $ERR;
        $Ready{ $self->{_id} }  = $self;
    }
    return;
}

sub _real_write {
    my ($self) = @_;
    return 1 if !defined $self->{out_buf};
    my $n = send $self->{fh}, $self->{out_buf}, 0, $self->{out_paddr};
    if (defined $n) {
        $self->{_tick_write}    = $Tick;
        #   ,  out_buf    , 
        #       EMSGSIZE.
        $self->{out_buf}        = undef;
        $self->{out_bytes}     += $n;
        if ($self->{wait_for} & $OUT) { # no $SENT for $UDP !
            $self->{_events}       |= $OUT;
            $Ready{ $self->{_id} }  = $self;
        }
        return 1;
    }
    elsif ($! != $EAGAIN) { #   EAGAIN  ģ,     ?
        $self->{_err}           = $!;
        $self->{_events}       |= $ERR;
        $Ready{ $self->{_id} }  = $self;
    }
    return 0;
}


package POWER::Event::IO::STREAM;
use base qw( POWER::Event::IO );
use Carp;
use Socket;
use Scalar::Util qw( dualvar );

use POWER::Epoll;

#  EINTR (  sysread/syswrite)  
#     EINTR      fh! :-/ 
# EINTR       .

#       ..   
#  ,       
#  EPOLLERR.
sub _init {
    my ($self) = @_;
    connect($self->{fh}, sockaddr_in($self->{port}, inet_aton($self->{ip})));
    return;
}

sub _real_read {
    my ($self) = @_;
    #     in_buf_limit.  
    #        ޣ
    # in_buf_limit,     .   in_buf_limit -
    #   DoS ,     
    # in_buf,        .
    my $len = length($self->{in_buf});
    if ($self->{in_buf_limit} && $len > $self->{in_buf_limit}) {
        $self->{_err}           = dualvar(-1, 'in_buf_limit reached');
        $self->{_events}       |= $ERR;
        $Ready{ $self->{_id} }  = $self;
        return;
    }
    #  ...   ...    ?
    my $n   = sysread $self->{fh}, $self->{in_buf}, 0xFFFF, $len;
    if (defined $n) {
        # WARNING     LT epoll  EOF?   
        #           EPOLLIN       EOF?
        if (!$n) {
            # $EOF     .
            if ($self->{wait_for} & $EOF && !$self->{is_eof}) {
                $self->{_events}       |= $EOF;
                $Ready{ $self->{_id} }  = $self;
            }
            if ($self->{wait_for} & $IN) {
                $self->{_events}       |= $IN;
                $Ready{ $self->{_id} }  = $self;
            }
            $self->{is_eof} = 1;
        }
        else {
            $self->{in_bytes} += $n;
            if ($self->{wait_for} & $IN) {
                $self->{_events}       |= $IN;
                $Ready{ $self->{_id} }  = $self;
            }
            if ($self->{in_buf_limit} && $len + $n > $self->{in_buf_limit}) {
                $self->{_err}           = dualvar(-1, 'in_buf_limit reached');
                $self->{_events}       |= $ERR;
                $Ready{ $self->{_id} }  = $self;
            }
        }
    }
    elsif ($! != $EAGAIN) { #   EAGAIN  ģ,     ?
        $self->{_err}           = $!;
        $self->{_events}       |= $ERR;
        $Ready{ $self->{_id} }  = $self;
    }
    return;
}

sub _real_write {
    my ($self) = @_;
    my $n;
    if (defined $self->{out_pos}) {
        return 1 if length($self->{out_buf}) <= $self->{out_pos};
        #  ...   ...    ?
        $n = syswrite $self->{fh}, $self->{out_buf}, 0xFFFF, $self->{out_pos};
    }
    else {
        return 1 if $self->{out_buf} eq q{};
        #  ...   ...    ?
        $n = syswrite $self->{fh}, $self->{out_buf}, 0xFFFF;
    }
    if (defined $n) {
        # die 'Internal error' if !$n;
        $self->{_tick_write} = $Tick;
        if ($self->{wait_for} & $OUT) {
            $self->{_events}       |= $OUT;
            $Ready{ $self->{_id} }  = $self;
        }
        $self->{out_bytes} += $n;
        if (defined $self->{out_pos}) {
            $self->{out_pos} += $n;
            return 0 if $self->{out_pos} < length($self->{out_buf});
            # die 'Internal error' if $self->{out_pos} > length($self->{out_buf});
        }
        else {
            substr($self->{out_buf}, 0, $n, q{});
            return 0 if $self->{out_buf} ne q{};
        }
        if ($self->{wait_for} & $SENT) {
            $self->{_events}       |= $SENT;
            $Ready{ $self->{_id} }  = $self;
        }
        return 1;
    }
    elsif ($! != $EAGAIN) { #   EAGAIN  ģ,     ?
        $self->{_err}           = $!;
        $self->{_events}       |= $ERR;
        $Ready{ $self->{_id} }  = $self;
    }
    return 0;
}


package POWER::Event::IO::LISTEN;
use base qw( POWER::Event::IO );
use Carp;
use Socket;
use Scalar::Util qw( dualvar );

#       ..   
#  ,       
#  EPOLLERR.
sub _init {
    my ($self) = @_;
    setsockopt($self->{fh}, $SOL_SOCKET, $SO_REUSEADDR, $REUSEADDR_VAL);
    bind($self->{fh}, sockaddr_in($self->{port}, inet_aton($self->{ip})));
    listen($self->{fh}, $SOMAXCONN);
    return;
}

sub _real_read {
    my ($self) = @_;
    return if defined $self->{in_buf};
    $self->{in_paddr} = accept $self->{in_buf}, $self->{fh};
    if (defined $self->{in_paddr}) {
        ioctl($self->{in_buf}, $FIONBIO, $IOCTL_TRUE) or croak "ioctl: $!";
        #  if     ..   wait_for 
        #  $ACCEPTED,   LISTEN  EPOLLIN  , 
        # _real_read()   ...
        if ($self->{wait_for} & $ACCEPTED) {
            $self->{_events}       |= $ACCEPTED;
            $Ready{ $self->{_id} }  = $self;
        }
    }
    elsif ($! != $EAGAIN) { #   EAGAIN  ģ,     ?
        $self->{_err}           = $!;
        $self->{_events}       |= $ERR;
        $Ready{ $self->{_id} }  = $self;
    }
    return;
}

sub _real_write {
    die 'Closed. Try again later, please...';
}


1; # Magic true value required at end of module
__END__

=head1 NAME

POWER::Event::IO - Async, event-based I/O object


=head1 VERSION

This document describes POWER::Event::IO version 0.0.2


=head1 SYNOPSIS

    use POWER::Utils::IO;
    use POWER::Event;
    use POWER::Event::IO;

    my $io = POWER::Event::IO->new({
        fh          => unix_client('/tmp/mysock'),
        wait_for    => $EOF,
        cb          => \&callback,
    });
    $io->write('some request');
    loop();
    sub callback {
        print "received reply: ", $io->{in_buf}
            if $io->{events} & $EOF;
        die $io->{err}
            if $io->{events} & $ERR;
    }

    POWER::Event::IO->new({
        host        => 'google.com',
        port        => 80,
        wait_for    => $IN|$SENT,
        cb          => 'Google',
        out_buf     => "GET / HTTP/1.0\nHost: google.com\n\n",
    });
    loop();
    sub Google::IO {
        my ($io) = @_;
        print "request sent!\n"
            if $io->{events} & $SENT;
        if ($io->{events} & $IN) {
            printf "just readed %d bytes\n", $io->{in_bytes};
            $io->{in_bytes} = 0;    # reset counter
            print "received reply: ", $io->{in_buf}
                if $io->{is_eof};
        }
    }

    POWER::Event::IO->new({
        type        => $UDP_CONNECTED,
        host        => '127.0.0.1',
        port        => 53,
        wait_for    => $IN,
        cb          => \&dns_resolver,
        out_buf     => "[dns request packet here]",
    });
    loop();
    sub dns_resolver {
        my ($io) = @_;
        if ($io->{events} & $IN) {
            [process $io->{in_buf} here...]
            $io->{in_buf} = undef; # ready for receiving next packet
        }
        die $io->{err}
            if $io->{events} & $ERR;
    }

    POWER::Event::IO->new({
        type        => $LISTEN,
        host        => '127.0.0.1',
        port        => 1234,
        wait_for    => $ACCEPTED,
        cb          => \&accept_client,
    });
    loop();
    sub accept_client {
        my ($io) = @_;
        die $io->{err}
            if $io->{events} & $ERR;
        my ($port, $iaddr) = sockaddr_in($io->{in_paddr});
        my $ip = inet_ntoa($iaddr);
        POWER::Event::IO->new({
            fh          => delete($io->{in_buf}),
            wait_for    => $IN|$EOF,
            cb          => \&server,
            ClientIP    => $ip,
            ClientPort  => $port,
        });
    }
    sub server {
        my ($io) = @_;
        printf "Got some bytes from %s:%d\n",
            $io->{ClientIP}, $io->{ClientPort}
            if $io->{events} & $IN;
        if ($io->{events} & ($EOF|$ERR)) {
            printf "Client %s:%d sent %d bytes:%s\n",
                $io->{ClientIP}, $io->{ClientPort},
                $io->{in_bytes}, $io->{in_buf}
            $io->close();
        }
    }

    POWER::Event::IO->new({
        fh          => tcp_client('localhost', 80),
        state       => $CONNECTING,
        wait_for    => $IN|$OUT,
        cb          => \&http_io,
        out_buf     => "GET / HTTP/1.1\nHost: localhost\n\n",
        out_pos     => 0,
    });
    sub http_io {
        my $io = shift;
        die "Can't fetch url: $io->{err}\n"     if $io->{events} & $ERR;
        shutdown $io->{fh}, SHUT_WR             if $io->{events} & $SENT;
        warn "Just readed : $io->{in_bytes}\n"  if $io->{events} & $IN;
        warn "Just got EOF!\n"                  if $io->{events} & $EOF;
        warn "At EOF.\n"                        if $io->{is_eof};
        warn "Just written: $io->{out_bytes}\n" if $io->{events} & $OUT;
        warn "Just finish writing!\n"           if $io->{events} & $SENT;
        warn "Written $io->{out_pos} bytes so long...\n";
        $io->{in_bytes}  = 0;
        $io->{out_bytes} = 0;
    }


=head1 DESCRIPTION

       I/O.
 ң     :  -,
,   ,   
    .

   ,      
 I/O,         ,
 I/O.

     callback -  
   I/O.

 أ        
   I/O   ,   
       --.
      POWER::Event::IO
  ,  - POWER::Event::IO    
   fh,  -   
POWER::Event::IO     
/       .


=head1 USAGE

 ,  POWER::Event::IO   fh,   
"".     POWER::Event::IO->new().
 ""   ,    
     new()  ,  
  POWER::Event::IO->new().  new(),  ,  
  ,       -
     :    fh 
        new()
callback       new() .
 ݣ new()      ,
        callback    .

=over 8

       POWER::Event, - 
POWER::Event::IO   ,   -  
loop()  POWER::Event,  -     callback.

=back

  fh  POWER::Event::IO    fh (, 
    )     write(),
   fh  close(). ݣ   wait_for()  
      callback.

          (,
,  ,      
  I/O). ,   fh     
{in_buf},           ( 
  callback   fh   $IN  $EOF)    
 ӣ,   - , , , etc.

=over

    ,     
 :   Σ     -  
      ,     
-      undef     ,  
   RO (read only) -    . 
     .

=back


=head1 LOW-LEVEL I/O

  fh  POWER::Event::IO      ӣ  
(bind/fcntl/sysread/syswrite/etc...).   fh 
POWER::Event::IO,    ң   POWER::Event::IO - 
  sysread/recv/accept, syswrite/send  close -    
    (       
, . shutdown, setsockopt, bind, fcntl, ioctl, stat, seek, etc.).

=over

     ,    
POWER::Event::IO     .     
  . :-)   POWER::Event::IO - 
/     ,  -  
   /.      
   -      EAGAIN   
     /...   
,     .

  -   fh    
close()  POWER::Event::IO,     close().

=back

 /   fh POWER::Event::IO   
 ,   IP-,  
      connect/bind/listen,  - 
   .      POWER::Event::IO,
       ,    .

       
,     :

 eof()          -  is_eof
 fileno()       -  fd
 getpeername()  -  paddr ( accept()- )


=head3 BLOCKING WARNING

  ,     callback   -
   !

 open
          
    FS    FIFO.
 opendir
          
    FS.
 flock


=head1 TYPES

 POWER::Event::IO    (    new()).
  -      ;   
     -:

                            
  $STREAM            sysread     syswrite
  $LISTEN             accept      -
  $UDP                recv        send
  $UDP_CONNECTED      sysread     syswrite

   write()      
  {out_buf},     
  {in_buf},        
 {out_pos} -       {out_buf},
  {out_pos}   -  .

         
    .     
write()      ,  ɣ  
     . (   
     Σ undef .. /ɣ 
   -   .)

  -    (c $RESOLVED  $CONNECTED
  $STREAM     ):

               
  $STREAM         $ERR|$RESOLVED|$CONNECTED|$IN|$OUT|$EOF|$SENT
  $LISTEN         $ERR|$RESOLVED|$ACCEPTED
  $UDP            $ERR|$IN|$OUT
  $UDP_CONNECTED  $ERR|$RESOLVED|$IN|$OUT


=head1 EXPORTS

=over

=item : 

$ERR $RESOLVED $CONNECTED $ACCEPTED $IN $OUT $EOF $SENT

=item :   POWER::Event::IO

$STREAM $LISTEN $UDP $UDP_CONNECTED

=item :   POWER::Event::IO

$RESOLVING $CONNECTING $HANDLING

=back


=head1 INTERFACE

=over

=item B<new( \%PARAMS )>

  -.

 %PARAMS     ,     
   :

    :
  fh    host + port
  cb
    :
  type
  wait_for
  state
  method
  in_buf_limit
  out_buf
  out_pos

  ,       
. L<Public FIELDS>.

     [A-Z].    
     new()      .
      I/O 
   ,       new()
       callback (   
).

  write()   out_buf     
.

  .


=item B<write( $DATA )>

=item B<write()>

 , $DATA    .    fh
(. L<TYPES>) $DATA     out_buf.  
 fh   write($DATA)  out_buf   undef ( 
  "previous packet isn't sent yet")  $DATA 
  out_buf.

  , write()    (  ,
, )     .  
   write()       out_buf,
      . :)    
   -  write()     
out_buf undef.

 write()        - 
out_buf  ,   -    ,  
write().        ,   
,          -
      write(),    .

   out_buf   ,     ,  
 write()    ()    
    .        out_buf
 out_pos       write().

  .


=item B<close()>

      ,    
        
.  fh (   close()).

  close()      -weaken
   (      ),
  POWER::Event::IO  .

  .


=item B<wait_for()>

wait_for()     .

   DoS       wait_for()
 $EOF   $IN  in_buf_limit.

   -  callback   
ݣ      ,     
wait_for().
      callback   
 ,     wait_for().

  .


=item B<io_wait>( TIMEOUT )

io_wait()     POWER::Event::loop().

Wait for one of:

 - some I/O events on FILEHANDLEs added by new()
 - TIMEOUT expires
 - signal arrives

Return: (STATUS, EVENTS), where:

 STATUS     if signal arrives     : undefined scalar
            if timeout expires    : 0
            if I/O events happens : positive number
 EVENTS     list with all I/O events in format suitable for
            POWER::Utils/run_callback()


=back


=head1 Public FIELDS

        
       .

       B<RO>   
  B<RW> ,   POWER::Event::IO  .

          
 _     (     
    )    [A-Z]
  (     new() /
//   ).


=over

=item B<fh>             I<RO>      new()

 filehandle    -.
        new(),
        
IP .      new()  
host  port.

=over

WARNING fh   .   -
  fh  .

=back


=item B<host>           I<RO>      new()

   fh    IP,  
fh   new()   host (    fh  host
 host  ). (   fh   
 socket()         
 IP.)

 host    IP  fh  
 :

   $STREAM  $UDP_CONNECTED:
    connect($self->{fh},
        sockaddr_in($self->{port}, inet_aton($self->{ip})));
   $LISTEN:
    setsockopt($self->{fh}, SOL_SOCKET, SO_REUSEADDR, pack('L!', 1));
    bind($self->{fh},
        sockaddr_in($self->{port}, inet_aton($self->{ip})));
    listen($self->{fh}, SOMAXCONN);

    wait_for $RESOLVED,    fh 
 callback.

=over

   POWER::Utils::IO    
 host : 'ANY', 'BROADCAST'  'LOOPBACK'  
   ..       
  fh.     , 
'ANY'   '0.0.0.0'  'LOOPBACK'  '127.0.0.1'.

=back


=item B<port>           I<RO>      new()

    fh (  fh  new()   host).


=item B<type>           I<RO>     new()

  -.  :

  $STREAM           - , TCP  UNIX(STREAM) 
  $LISTEN           -  TCP  UNIX(STREAM) 
  $UDP              - UDP-     connect()
  $UDP_CONNECTED    - UDP-    connect()

   $STREAM.


=item B<state>          I<RO>     new()

  fh.  :

  $RESOLVING        - fh  ,  IP 
  $CONNECTING       - fh ,  connect
  $HANDLING         - fh   -

 state   new():

     fh                      -> $RESOLVING
     state=$CONNECTING   -> $CONNECTING
                                   -> $HANDLING

  state  :

  $RESOLVED     -> $CONNECTING   $STREAM
  $RESOLVED     -> $HANDLING     
  $CONNECTED    -> $HANDLING

  $STREAM    new()  state=$CONNECTING.
   new()   $STREAM   state=$CONNECTING 
    state=$CONNECTING  
   ģ     
   .


=item B<wait_for>       I<RO>    new()  wait_for()

 ,     callback.  :

  $ERR              -  ,       err
  $RESOLVED         - host , IP    ip
  $CONNECTED        -  ۣ
  $ACCEPTED         -   ,    in_buf,
                      paddr ݣ accept()-  paddr
  $IN               -       in_buf,
                      -     in_bytes
  $OUT              -  ()    out_buf,
                      -     out_bytes
  $EOF              -   EOF,   is_eof
  $SENT             - out_buf      

     ( 0).

 $ERR        wait_for.

  wait_for      $ACCEPTED|$IN|$EOF, 
  fh   .

    :

 $ERR
      ,     close().
            /
      ,     
       $ERR.
     WARNING     I/O   
      (     )
     __  callback  .   callback 
     write()        
     ,    write()    
       $ERR (,  - ).
 $RESOLVED
 $CONNECTED
       ;  ; etc.
 $ACCEPTED
         -  
          .
 $IN
      in_buf / in_bytes.   
         (     
     -)     in_buf  .
 $OUT
       ;  ; write().
 $EOF
       ; write(); close().
 $SENT
      shutdown(SHUT_WR)   EOF; write(); close().


=item B<cb>             I<RO>    new()

=item B<method>         I<RO>     new()

callback (  POWER::Utils::run_callback()),  
      wait_for.

  callback    -  -;
      events.

  callback .

  callback    
 (   $ERR   I/O).

=over

WARNING   callback   fork(),    
""  I/O  £     .

=back


=item B<in_buf_limit>   I<RW>     new()

   in_buf.  :

  undef             -   
  0                 -  
                      ( ,  DoS )
  >0                -   in_buf

  : undef.

  ,      wait_for
 $EOF    $IN -    in_buf_limit 
 ̣.

 in_buf     in_buf_limit 
 $ERR (err='in_buf_limit reached')   ɣ 
    in_buf    in_buf_limit.


=item B<out_buf>        I<RW>     new()

 .

   ,    :
  ( )    .
   ,    :
undef ( )   ( ..   ..  
 UDP-).

  out_buf    new(),  new() 
 write().


=item B<out_pos>        I<RW>     new()

   write()  out_buf.  :

  undef         - write()     out_buf,
                      out_buf
  >=0           - write()       out_buf,
                  out_pos   -  

  : undef.

    .


=item B<events>         I<RO>    callback

  , . wait_for.


=item B<err>            I<RO>    callback   $ERR

    (dualvar,  $!).
   $!.

     (..     $!)
   -1.   :

 resolving timed out
 connecting timed out
 writing timed out
 too long host name
 dns error: NXDOMAIN
 dns error: SRVERROR
 dns error: NODATA
 in_buf_limit reached


=item B<in_buf>         I<RW>

 .  : . out_buf.

  $LISTEN    ݣ  accept().


=item B<in_bytes>       I<RW>

ޣ  .
  : 0.

 ޣ        -
 .

       ,     
 .


=item B<in_paddr>       I<RW>

 paddr ݣ  accept()   $LISTEN.

 paddr ݣ  recv()   $UDP.


=item B<out_bytes>      I<RW>

ޣ  .
. in_bytes.


=item B<out_paddr>      I<RW>

 paddr   send()   $UDP.


=item B<ip>             I<RW>

 IP-    new()  fh   host.


=item B<is_eof>         I<RO>

 EOF:     EOF,    EOF.

   $EOF  ,  $EOF   callback 
 ,      wait_for,    
   EOF    .


=item B<fd>             I<RO>

  fileno(fh),      fileno().


=back


=head1 TIMEOUTS

      
POWER::Event::IO.

    .. "".  
  ( )  ""   
$POWER::Event::IO::TICK_RATE (. 1     ,  0.1
 10   ).  ,  , ,
  connect()  15   :

 # int  +0.5    ,   
 #    1 
 $POWER::Event::IO::TO_CONNECT
    = int 15 / $POWER::Event::IO::TICK_RATE + 0.5;

   ( TO_DNS_RESEND, ) 
 $ERR.  err     -1   
 .

=over

=item $POWER::Event::IO::TICK_RATE

.   .


=item $POWER::Event::IO::TO_DNS

   IP    new()  host  fh.

  30 .   : "resolving timed out".


=item $POWER::Event::IO::TO_DNS_RESEND

      DNS-    .

  2 .


=item $POWER::Event::IO::TO_CONNECT

   connect().   type=$STREAM  
 host,    new()  state=$CONNECTING.

  30 .   : "connecting timed out".


=item $POWER::Event::IO::TO_WRITE

     ()   
.

  30 .   : "writing timed out".


=back


=head1 $SIG{PIPE}

  POWER::Event::IO     
$SIG{PIPE}  'IGNORE'    $SIG{PIPE}    .
.


=head1 SUPPORTED FILEHANDLE TYPES

.. POWER::Event::IO   epoll,   
"pollable" filehandles.   "pollable" fh    ,
   socket, pipe  fifo "pollable". ݣ  
    sysfs  "pollable".


=over

=item  

Not supported.

  I/O    (  -
    ).     .


=item  ,   Network FS

Not supported.

  I/O  100%,    
   -   , .


=item   . FS - procfs, devfs(udev), tmpfs, etc.

Partially supported.

   I/O   fs:
 tmpfs   ,   procfs  devfs  
   (     ).

   : /proc/version (), /dev/null (),
/dev/zero (), /dev/random (), /dev/urandom ().  
"pollable"  /dev/random.


=item TTY

Supported, but not recommended to use.

 I/O . Epoll  STDIN/STDOUT/STDERR   .


=item UNIX-

Supported.

      SOCK_STREAM ($STREAM).
 ,   SOCK_DGRAM unix-    
  SOCK_STREAM  SOCK_DGRAM.


=item INET- TCP (SOCK_STREAM)

Supported.

   ($STREAM)   ($LISTEN).


=item INET- UDP (SOCK_DGRAM)

Supported.

   ($UDP_CONNECTED)    ($UDP).


=item INET- RAW & other non-TCP/UDP; PACKET (non-IP) socket

??? Not tested yet.   .

   POWER::Event::IO   .
 I/O     sysread/syswrite,  
    $STREAM .


=item PIPE

Supported.

 I/O .


=item FIFO

Supported.

    I/O,   open.


=item Inotify

??? Not tested yet.   .


=item Directory

Not supported.

 I/O     .

     ,  fileno(DIRHANDLE)  undef,
   epoll    . :)


=back


=head1 REALIZATION

  I/O  epoll(2)   POWER::Epoll.

    callback    POWER::Event,
    I/O    -
, , etc.

     POWER::Event::Timer.

    nameserver   /etc/resolv.conf
 127.0.0.1.


=head1 DIAGNOSTICS

=head2 EXCEPTIONS

=over

=item C<< Oops. DNS resolver just died: %s" >>

 UDP- Σ  DNS-   $ERR.


=item C<< don't know what to do with resolved IP for UDP >>

  new()   $UDP  host  fh.   
  host ..      IP .


=item C<< Closed. Try again later, please... >>

  write()   out_buf  new()   $LISTEN. :-)


=item C<< Usage: POWER::Event::IO->new({ OPTIONS }) >>

new()       -   .


=item C<< {cb} required >>

    new()   ̣ {cb}.


=item C<< {type} wrong >>

    new()    {type}.


=item C<< only allowed value to initialize {state} is $CONNECTING >>

    new()   {state},     $CONNECTING.


=item C<< you can set {state} only if {type} support $CONNECTED >>

    new()   {state},    
  $CONNECTED       $CONNECTING.


=item C<< socket: $! >>

    new()    {fh},   
  .


=item C<< {fh} or {host}+{port} required >>

    new()    {fh}     {host}  {port}.


=item C<< {fh} is not open FILEHANDLE >>

    new()    {fh}.


=item C<< you must do $io->close() first >>

 new()          
 fileno()       close().


=item C<< Usage: $io->wait_for( FLAGS ) >>

wait_for()    .


=item C<< wrong event mask >>

   wait_for()   {wait_for}  new() 
: undef         .


=item C<< you must set {in_buf_limit} if you wanna $EOF without $IN >>

   wait_for()   {wait_for}  new() $EOF  $IN,
     {in_buf_limit} undef.


=item C<< Usage: $io->write( [$buf] ) >>

write()        .


=item C<< previous packet isn't sent yet >>

  write()     ,     out_buf
 undef.


=item C<< usage: io_wait TIMEOUT >>

io_wait()     .


=item C<< wrong TIMEOUT $timeout >>

 io_wait()   undef   >= 0.


=item C<< Internal error: no I/O object for events=$events on fd=$fd >>

io_wait()   epoll_wait()     I/O.


=back


=head2 WARNINGS

None.


=head1 CONFIGURATION AND ENVIRONMENT

POWER::Event::IO uses only configuration file: /etc/resolv.conf.


=head1 DEPENDENCIES

 Perl6::Export::Attrs

 POWER::Epoll           2.0.0
 POWER::Event::Timer


=head1 INCOMPATIBILITIES

None reported.


=head1 BUGS AND LIMITATIONS

No bugs have been reported.

Please report any bugs or feature requests to
C<bug-power-event-io@rt.cpan.org>, or through the web interface at
L<http://rt.cpan.org>.


=head1 AUTHOR

Alex Efros  <powerman@asdfgroup.com>


=head1 LICENCE AND COPYRIGHT

Copyright (c) 2006, Alex Efros <powerman@asdfgroup.com>. All rights reserved.

This module is free software; you can redistribute it and/or
modify it under the same terms as Perl itself. See L<perlartistic>.


=head1 DISCLAIMER OF WARRANTY

BECAUSE THIS SOFTWARE IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE SOFTWARE, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE SOFTWARE "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOFTWARE IS WITH
YOU. SHOULD THE SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL
NECESSARY SERVICING, REPAIR, OR CORRECTION.

IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE SOFTWARE AS PERMITTED BY THE ABOVE LICENCE, BE
LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL,
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE
THE SOFTWARE (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
FAILURE OF THE SOFTWARE TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGES.
